import {
  TerminusEndpoint,
  TerminusOptionsFactory,
  TerminusModuleOptions,
} from '@nestjs/terminus';
import { Injectable } from '@nestjs/common';
import { SmtpHealthIndicator } from './smtp.healthIndicator';

@Injectable()
export class HealthCheckService implements TerminusOptionsFactory {
  constructor(
    private readonly _smtpHealthIndicator: SmtpHealthIndicator,
  ) { }

  createTerminusOptions(): TerminusModuleOptions {
    const healthEndpoint: TerminusEndpoint = {
      url: '/health',
      healthIndicators: [
        async () => this._smtpHealthIndicator.checkSMTPConnection(),
      ],
    };
    return {
      endpoints: [healthEndpoint],
    };
  }
}